/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * Principal.java
 *
 * Created on 19-oct-2009, 12:19:10
 */

package PaqueteFormularios;

import PaqueteJuego.*;
import java.awt.*;
import java.awt.event.MouseEvent; 
import java.io.File;
import javax.swing.*;
import java.util.Observer;
import java.util.Observable;
import java.net.*;
import javax.imageio.ImageIO.*;
import java.awt.image.BufferedImage;

/**
 *  @author root
 */
// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.3166F1C6-58F4-CBC4-F6E6-E6411136E6A6]
// </editor-fold> 
public class Principal extends JFrame implements Observer {
    private static java.awt.Color Color1=java.awt.Color.MAGENTA;
    private static java.awt.Color Color2=java.awt.Color.BLUE;
    private static java.awt.Color Color3=java.awt.Color.RED;
    private static java.awt.Color Color4=java.awt.Color.BLACK;
    private static java.awt.Color Color5=java.awt.Color.GREEN;
    private static java.awt.Color Color6=java.awt.Color.CYAN;

    private Juego J;
    private Tablero T;
    private BufferedImage Mapa;
    private javax.swing.JPanel Dados;
    private javax.swing.JPanel Rearmar;
    private javax.swing.JPanel Cartas;

    /**
     *  Creates new form Principal
     * @param J
     */
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.CB5C688A-E8F2-9521-1FAD-458F27EF7419]
    // </editor-fold> 
    public Principal (Juego J) {
      
       setJuego(J);
       String curDir = System.getProperty("user.dir");


       setNombreMapa(CargarImagen(curDir+"/mapas/Mapa.png"));
       initComponents();
       EtiquetaNombreMapa.setText(curDir);
       PanelPrincipal.setEnabledAt(1,false);
       PanelNombres.setLayout(new java.awt.GridLayout(6,1));

       this.setLocationRelativeTo(null);

    }

    /**
     *
     * @param val
     */
    public void setJuego(Juego val){
        this.J=val;
    }

    /**
     *
     * @return
     */
    public Juego getJuego(){
        return this.J;
    }

    /**
     *
     * @return
     */
    public Tablero getTablero() {
        return this.T;
    }

    /**
     *
     * @param val
     */
    public void setTablero(Tablero val) {
        this.T=val;
    }

    /**
     *
     * @param val
     */
    public void setDados(Dados val){
        this.Dados=val;
    }

    /**
     *
     * @return
     */
    public javax.swing.JPanel getDados(){
        return this.Dados;
    }

    /**
     *
     * @param val
     */
    public void setRearmar(Rearmar val){
        this.Rearmar=val;
    }

    /**
     *
     * @return
     */
    public javax.swing.JPanel getRearmar(){
        return this.Rearmar;
    }

    /**
     *
     * @param val
     */
    public void setCartas(Cartas val){
        this.Cartas=val;
    }

    /**
     *
     * @return
     */
    public javax.swing.JPanel getCartas(){
        return this.Cartas;
    }

    /**
     *
     * @param val
     */
    public void setNombreMapa(java.awt.image.BufferedImage val){
        this.Mapa=val;
    }

    /**
     *
     * @return
     */
    public java.awt.image.BufferedImage getNombreMapa(){
        return this.Mapa;
    }

    /**
     *
     * @param Pa
     * @param Fondo
     */
    public void InicializaTablero(Partida Pa,BufferedImage Fondo) {
       Tablero Ta = this.getTablero();
        if (Ta==null){
                Ta=new Tablero(J.getTerritorios(),Pa,Fondo);

                this.setTablero(Ta);
        }

    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        PanelPrincipal = new javax.swing.JTabbedPane();
        PanelConfiguracion = new javax.swing.JPanel();
        PanelNombres = new javax.swing.JPanel();
        NombreJugador = new javax.swing.JTextField();
        EtiquetaNombre = new javax.swing.JLabel();
        BotonIncluir = new javax.swing.JButton();
        BotonJugar = new javax.swing.JButton();
        BotonEliminar = new javax.swing.JButton();
        EtiquetaRondas = new javax.swing.JLabel();
        NumeroRondas = new javax.swing.JSpinner();
        SeleccionAleatoria = new javax.swing.JCheckBox();
        BotonMapa = new javax.swing.JButton();
        EtiquetaNombreMapa = new javax.swing.JLabel();
        EtiquetaTipoJuego = new javax.swing.JLabel();
        TipoJuego = new javax.swing.JComboBox();
        PanelTablero = new javax.swing.JPanel();
        VisorTablero = new javax.swing.JPanel();
        EtiquetaJugador = new javax.swing.JLabel();
        InformacionTurno = new javax.swing.JLabel();
        EtiquetaInformacion = new javax.swing.JLabel();
        BotonCambioTurno = new javax.swing.JButton();
        BotonCartas = new javax.swing.JButton();
        BotonAtacar = new javax.swing.JButton();
        BotonRearmar = new javax.swing.JButton();
        BotonTerminar = new javax.swing.JButton();
        EtiquetaInfoRonda = new javax.swing.JLabel();
        EtiquetaMarcadorTurno = new javax.swing.JLabel();
        Menu = new javax.swing.JMenuBar();
        MenuArchivo = new javax.swing.JMenu();
        GuardarPartida = new javax.swing.JMenuItem();
        CargarPartida = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JSeparator();
        Salir = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("RISKAI");
        setBackground(new java.awt.Color(183, 178, 172));

        PanelPrincipal.setBorder(null);
        PanelPrincipal.setDoubleBuffered(true);

        PanelConfiguracion.setBackground(new java.awt.Color(200, 200, 200));
        PanelConfiguracion.setRequestFocusEnabled(false);

        PanelNombres.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        PanelNombres.setMinimumSize(new java.awt.Dimension(155, 200));
        PanelNombres.setPreferredSize(new java.awt.Dimension(20, 10));

        javax.swing.GroupLayout PanelNombresLayout = new javax.swing.GroupLayout(PanelNombres);
        PanelNombres.setLayout(PanelNombresLayout);
        PanelNombresLayout.setHorizontalGroup(
            PanelNombresLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 1008, Short.MAX_VALUE)
        );
        PanelNombresLayout.setVerticalGroup(
            PanelNombresLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 107, Short.MAX_VALUE)
        );

        NombreJugador.setPreferredSize(new java.awt.Dimension(20, 10));

        EtiquetaNombre.setText("Nombre Jugador:");
        EtiquetaNombre.setPreferredSize(new java.awt.Dimension(20, 10));

        BotonIncluir.setText("Incluir");
        BotonIncluir.setPreferredSize(new java.awt.Dimension(20, 10));
        BotonIncluir.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                BotonIncluirMouseClicked(evt);
            }
        });

        BotonJugar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/PaqueteImagenes/Capitan.png"))); // NOI18N
        BotonJugar.setText("PLAY");
        BotonJugar.setActionCommand(" PLAY");
        BotonJugar.setDoubleBuffered(true);
        BotonJugar.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        BotonJugar.setPreferredSize(new java.awt.Dimension(20, 10));
        BotonJugar.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        BotonJugar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                BotonJugarMouseClicked(evt);
            }
        });

        BotonEliminar.setText("Eliminar");
        BotonEliminar.setPreferredSize(new java.awt.Dimension(20, 10));
        BotonEliminar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                BotonEliminarMouseClicked(evt);
            }
        });

        EtiquetaRondas.setText("Numero Rondas:");
        EtiquetaRondas.setPreferredSize(new java.awt.Dimension(20, 10));

        NumeroRondas.setModel(new javax.swing.SpinnerNumberModel(50, 1, 500, 1));
        NumeroRondas.setPreferredSize(new java.awt.Dimension(20, 10));

        SeleccionAleatoria.setBackground(new java.awt.Color(200, 200, 200));
        SeleccionAleatoria.setSelected(true);
        SeleccionAleatoria.setText("Seleccion Aleatoria de Territorios");

        BotonMapa.setText("Seleccionar Mapa");
        BotonMapa.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                BotonMapaMouseClicked(evt);
            }
        });

        EtiquetaNombreMapa.setText("Mapa por Defecto");

        EtiquetaTipoJuego.setText("Tipo de Juego:");

        TipoJuego.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Dominacion", "Capitales" }));

        javax.swing.GroupLayout PanelConfiguracionLayout = new javax.swing.GroupLayout(PanelConfiguracion);
        PanelConfiguracion.setLayout(PanelConfiguracionLayout);
        PanelConfiguracionLayout.setHorizontalGroup(
            PanelConfiguracionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(PanelConfiguracionLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(PanelConfiguracionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(PanelNombres, javax.swing.GroupLayout.DEFAULT_SIZE, 1010, Short.MAX_VALUE)
                    .addComponent(BotonEliminar, javax.swing.GroupLayout.DEFAULT_SIZE, 1010, Short.MAX_VALUE)
                    .addComponent(BotonJugar, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 1010, Short.MAX_VALUE)
                    .addGroup(PanelConfiguracionLayout.createSequentialGroup()
                        .addComponent(EtiquetaNombre, javax.swing.GroupLayout.PREFERRED_SIZE, 180, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 35, Short.MAX_VALUE)
                        .addComponent(NombreJugador, javax.swing.GroupLayout.PREFERRED_SIZE, 795, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(BotonIncluir, javax.swing.GroupLayout.DEFAULT_SIZE, 1010, Short.MAX_VALUE)
                    .addGroup(PanelConfiguracionLayout.createSequentialGroup()
                        .addComponent(EtiquetaRondas, javax.swing.GroupLayout.PREFERRED_SIZE, 137, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 28, Short.MAX_VALUE)
                        .addComponent(NumeroRondas, javax.swing.GroupLayout.PREFERRED_SIZE, 845, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(PanelConfiguracionLayout.createSequentialGroup()
                        .addComponent(EtiquetaTipoJuego, javax.swing.GroupLayout.PREFERRED_SIZE, 119, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 24, Short.MAX_VALUE)
                        .addComponent(TipoJuego, javax.swing.GroupLayout.PREFERRED_SIZE, 867, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, PanelConfiguracionLayout.createSequentialGroup()
                        .addComponent(EtiquetaNombreMapa, javax.swing.GroupLayout.PREFERRED_SIZE, 259, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(BotonMapa, javax.swing.GroupLayout.PREFERRED_SIZE, 739, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(SeleccionAleatoria, javax.swing.GroupLayout.DEFAULT_SIZE, 1010, Short.MAX_VALUE))
                .addContainerGap())
        );
        PanelConfiguracionLayout.setVerticalGroup(
            PanelConfiguracionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(PanelConfiguracionLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(PanelConfiguracionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(EtiquetaNombre, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(NombreJugador, javax.swing.GroupLayout.PREFERRED_SIZE, 28, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(BotonIncluir, javax.swing.GroupLayout.PREFERRED_SIZE, 35, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(40, 40, 40)
                .addComponent(PanelNombres, javax.swing.GroupLayout.PREFERRED_SIZE, 109, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(BotonEliminar, javax.swing.GroupLayout.DEFAULT_SIZE, 33, Short.MAX_VALUE)
                .addGap(44, 44, 44)
                .addGroup(PanelConfiguracionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(BotonMapa)
                    .addComponent(EtiquetaNombreMapa))
                .addGap(33, 33, 33)
                .addComponent(SeleccionAleatoria, javax.swing.GroupLayout.DEFAULT_SIZE, 21, Short.MAX_VALUE)
                .addGap(39, 39, 39)
                .addGroup(PanelConfiguracionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(EtiquetaRondas, javax.swing.GroupLayout.PREFERRED_SIZE, 19, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(NumeroRondas, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(70, 70, 70)
                .addGroup(PanelConfiguracionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(EtiquetaTipoJuego, javax.swing.GroupLayout.DEFAULT_SIZE, 17, Short.MAX_VALUE)
                    .addComponent(TipoJuego))
                .addGap(72, 72, 72)
                .addComponent(BotonJugar, javax.swing.GroupLayout.PREFERRED_SIZE, 81, Short.MAX_VALUE)
                .addContainerGap())
        );

        PanelPrincipal.addTab("Configuracion", PanelConfiguracion);

        PanelTablero.setBackground(new java.awt.Color(200, 200, 200));

        VisorTablero.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        VisorTablero.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                VisorTableroComponentResized(evt);
            }
        });

        javax.swing.GroupLayout VisorTableroLayout = new javax.swing.GroupLayout(VisorTablero);
        VisorTablero.setLayout(VisorTableroLayout);
        VisorTableroLayout.setHorizontalGroup(
            VisorTableroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 1006, Short.MAX_VALUE)
        );
        VisorTableroLayout.setVerticalGroup(
            VisorTableroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 595, Short.MAX_VALUE)
        );

        EtiquetaJugador.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        EtiquetaJugador.setOpaque(true);

        InformacionTurno.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));

        EtiquetaInformacion.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        EtiquetaInformacion.setPreferredSize(new java.awt.Dimension(10, 10));

        BotonCambioTurno.setIcon(new javax.swing.ImageIcon(getClass().getResource("/PaqueteImagenes/Avanzar.png"))); // NOI18N
        BotonCambioTurno.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                BotonCambioTurnoMouseClicked(evt);
            }
        });

        BotonCartas.setIcon(new javax.swing.ImageIcon(getClass().getResource("/PaqueteImagenes/Carta.png"))); // NOI18N
        BotonCartas.setToolTipText("Ver Cartas");
        BotonCartas.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                BotonCartasMouseClicked(evt);
            }
        });

        BotonAtacar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/PaqueteImagenes/Ataque.png"))); // NOI18N
        BotonAtacar.setToolTipText("Atacar");
        BotonAtacar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                BotonAtacarMouseClicked(evt);
            }
        });

        BotonRearmar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/PaqueteImagenes/Rearmar.png"))); // NOI18N
        BotonRearmar.setToolTipText("Rearmar");
        BotonRearmar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                BotonRearmarMouseClicked(evt);
            }
        });

        BotonTerminar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/PaqueteImagenes/Cerrar.png"))); // NOI18N
        BotonTerminar.setToolTipText("Terminar Partida");
        BotonTerminar.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        BotonTerminar.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                BotonTerminarMouseClicked(evt);
            }
        });

        EtiquetaInfoRonda.setFont(new java.awt.Font("DejaVu Sans", 1, 14));
        EtiquetaInfoRonda.setText("Nº Rondas");
        EtiquetaInfoRonda.setAutoscrolls(true);
        EtiquetaInfoRonda.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));

        EtiquetaMarcadorTurno.setFont(new java.awt.Font("DejaVu Sans", 1, 36));
        EtiquetaMarcadorTurno.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        EtiquetaMarcadorTurno.setText("50");
        EtiquetaMarcadorTurno.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        EtiquetaMarcadorTurno.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        javax.swing.GroupLayout PanelTableroLayout = new javax.swing.GroupLayout(PanelTablero);
        PanelTablero.setLayout(PanelTableroLayout);
        PanelTableroLayout.setHorizontalGroup(
            PanelTableroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(PanelTableroLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(PanelTableroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(VisorTablero, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(PanelTableroLayout.createSequentialGroup()
                        .addGroup(PanelTableroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(InformacionTurno, javax.swing.GroupLayout.DEFAULT_SIZE, 202, Short.MAX_VALUE)
                            .addComponent(EtiquetaInformacion, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(EtiquetaJugador, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(PanelTableroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(EtiquetaMarcadorTurno, javax.swing.GroupLayout.PREFERRED_SIZE, 86, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(EtiquetaInfoRonda))
                        .addGap(78, 78, 78)
                        .addComponent(BotonCambioTurno, javax.swing.GroupLayout.DEFAULT_SIZE, 101, Short.MAX_VALUE)
                        .addGap(62, 62, 62)
                        .addComponent(BotonCartas, javax.swing.GroupLayout.DEFAULT_SIZE, 98, Short.MAX_VALUE)
                        .addGap(12, 12, 12)
                        .addComponent(BotonAtacar, javax.swing.GroupLayout.DEFAULT_SIZE, 100, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(BotonRearmar, javax.swing.GroupLayout.DEFAULT_SIZE, 99, Short.MAX_VALUE)
                        .addGap(61, 61, 61)
                        .addComponent(BotonTerminar, javax.swing.GroupLayout.DEFAULT_SIZE, 99, Short.MAX_VALUE)))
                .addContainerGap())
        );
        PanelTableroLayout.setVerticalGroup(
            PanelTableroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, PanelTableroLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(VisorTablero, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(PanelTableroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(PanelTableroLayout.createSequentialGroup()
                        .addComponent(InformacionTurno, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(EtiquetaInformacion, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(EtiquetaJugador, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(PanelTableroLayout.createSequentialGroup()
                        .addComponent(EtiquetaInfoRonda, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(PanelTableroLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(BotonTerminar, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(BotonRearmar, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(BotonAtacar, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(BotonCambioTurno, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(BotonCartas, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(EtiquetaMarcadorTurno, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
                .addContainerGap())
        );

        PanelPrincipal.addTab("Tablero", PanelTablero);

        MenuArchivo.setText("Archivo");

        GuardarPartida.setText("Guardar Partida");
        MenuArchivo.add(GuardarPartida);

        CargarPartida.setText("Cargar Partida");
        MenuArchivo.add(CargarPartida);
        MenuArchivo.add(jSeparator1);

        Salir.setText("Salir");
        Salir.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                SalirMousePressed(evt);
            }
        });
        MenuArchivo.add(Salir);

        Menu.add(MenuArchivo);

        setJMenuBar(Menu);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(PanelPrincipal)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(PanelPrincipal)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    //Finaliza la configuracion e inicia una partida en la pestaña de tablero
    private void BotonJugarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_BotonJugarMouseClicked
        // TODO add your handling code here:
        if(J.TotalJugadores()>1){
            if(J.TotalJugadores()==2){
                J.CreaJugadorNeutral();
            }
            
            int TT=Integer.parseInt(NumeroRondas.getModel().getValue().toString());

            if(EtiquetaNombreMapa.getText().equals("Mapa por Defecto")){
                String curDir = System.getProperty("user.dir");

                getJuego().InicializaPartida(TipoJuego.getSelectedIndex(),TT,SeleccionAleatoria.isSelected(),curDir+"/mapas/Mapa.png.Cartas",curDir+"/mapas/Mapa.png.Territorios");
            }else{
                getJuego().InicializaPartida(TipoJuego.getSelectedIndex(),TT,SeleccionAleatoria.isSelected(),EtiquetaNombreMapa.getText()+".Cartas",EtiquetaNombreMapa.getText()+".Territorios");
            }

            getJuego().getPartida().addObserver(this);
            InicializaTablero(getJuego().getPartida(),getNombreMapa());
            
            VisorTablero.add(getTablero(),BorderLayout.CENTER);
            getTablero().setBounds(0,0,VisorTablero.getWidth(), VisorTablero.getHeight());
            getTablero().setVisible(true);

            PanelPrincipal.setSelectedComponent(PanelTablero);
            PanelPrincipal.setEnabledAt(0,false);
            PanelPrincipal.setEnabledAt(1,true);
            
            CambiaEstadoConponentes(false,false,false,false,"Selecciona Territorio","");
            EtiquetaMarcadorTurno.setText(""+getJuego().getPartida().getTotalTurnos());
            EtiquetaJugador.setBackground(J.getPartida().getJugadorTurno().getColor());
            EtiquetaJugador.setForeground(Color.WHITE);
            EtiquetaJugador.setText(J.getPartida().getJugadorTurno().getNombre());
            getJuego().getPartida().CompruebaTurno();
        }else{
             CreaAviso("Error","Deben existir al menos 2 jugadores");
        }
     
      
    }//GEN-LAST:event_BotonJugarMouseClicked

    //Añade un jugador
    private void BotonIncluirMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_BotonIncluirMouseClicked
        // TODO add your handling code here:
        if(J.TotalJugadores()<6){
            if(NombreJugador.getText().isEmpty()){
                 CreaAviso("Error","Debe escribir un nombre de jugador");
            }else{
                java.awt.Color Color=Color1;

                switch (getJuego().TotalJugadores()){
                    case 0: Color=Color1;
                            break;
                    case 1: Color=Color2;
                            break;
                    case 2: Color=Color3;
                            break;
                    case 3: Color=Color4;
                            break;
                    case 4: Color=Color5;
                            break;
                    case 5: Color=Color6;

                }
                J.IncluyeJugador(NombreJugador.getText(),1, Color);
            }
        }else{
            CreaAviso("Error","Numero maximo de jugadores 6.");
        }
    }//GEN-LAST:event_BotonIncluirMouseClicked

    //Termina partida y vuelve a la pestaña de configuracion
    private void BotonTerminarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_BotonTerminarMouseClicked
        // TODO add your handling code here:
       
        Jugador Ju=J.getPartida().DameJugadorGanador();
        CreaAviso("Resultado","Jugador Ganador: "+Ju.getNombre());

        J.EliminaJugadorNeutral();
        
        setTablero(null);
        getJuego().getPartida().deleteObservers();
        getJuego().FinalizaPartida();
       
        VisorTablero.removeAll();
        PanelPrincipal.setSelectedComponent(PanelConfiguracion);
        PanelPrincipal.setEnabledAt(1,false);
        PanelPrincipal.setEnabledAt(0,true);
        
    }//GEN-LAST:event_BotonTerminarMouseClicked

    private void BotonEliminarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_BotonEliminarMouseClicked
        // TODO add your handling code here:
        if(J.TotalJugadores()>0){
            J.EliminaJugador(J.getJugadores().get(J.TotalJugadores()-1));
        }
    }//GEN-LAST:event_BotonEliminarMouseClicked

    private void VisorTableroComponentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_VisorTableroComponentResized
        // TODO add your handling code here:
        if (getJuego().getPartida()!=null){
            getTablero().setBounds(0,0,VisorTablero.getWidth(), VisorTablero.getHeight());
            getTablero().paint(VisorTablero.getGraphics());
        }
    }//GEN-LAST:event_VisorTableroComponentResized

    private void BotonAtacarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_BotonAtacarMouseClicked
        // TODO add your handling code here:
        if(J.getPartida().getTurnoActual()==3){
            javax.swing.JDialog Ventana=new javax.swing.JDialog(this,"Atacar", java.awt.Dialog.ModalityType.APPLICATION_MODAL);
            if(getDados()==null){
                Dados Panel=new Dados(Ventana,getJuego().getPartida());
                setDados(Panel);
            }else{
                setDados(null);
                Dados Panel=new Dados(Ventana,getJuego().getPartida());
                setDados(Panel);
            }
            Ventana.add(getDados());
            getDados().setVisible(true);
            Ventana.pack();
            Ventana.setLocationRelativeTo(null);
            Ventana.setVisible(true);
        }
      
    }//GEN-LAST:event_BotonAtacarMouseClicked

    private void BotonRearmarMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_BotonRearmarMouseClicked
        // TODO add your handling code here:
        if(J.getPartida().getTurnoActual()==4){
            javax.swing.JDialog Ventana=new javax.swing.JDialog(this,"Rearmar", java.awt.Dialog.ModalityType.APPLICATION_MODAL);
            if(getRearmar()==null){
                Rearmar Panel=new Rearmar(Ventana,getJuego().getPartida());
                setRearmar(Panel);
            }else{
                setRearmar(null);
                Rearmar Panel=new Rearmar(Ventana,getJuego().getPartida());
                setRearmar(Panel);
            }
            Ventana.add(getRearmar());
            getRearmar().setVisible(true);
            Ventana.pack();
            Ventana.setLocationRelativeTo(null);
            Ventana.setVisible(true);
        }

    }//GEN-LAST:event_BotonRearmarMouseClicked

    private void BotonCambioTurnoMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_BotonCambioTurnoMouseClicked
        // TODO add your handling code here:
        getJuego().getPartida().CompruebaTurno();
    }//GEN-LAST:event_BotonCambioTurnoMouseClicked

    private void BotonCartasMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_BotonCartasMouseClicked
        // TODO add your handling code here:
        if(J.getPartida().getTurnoActual()==2){
            javax.swing.JDialog Ventana=new javax.swing.JDialog(this,"Cartas", java.awt.Dialog.ModalityType.APPLICATION_MODAL);
            if(getCartas()==null){
                Cartas Panel=new Cartas(Ventana,getJuego().getPartida());
                setCartas(Panel);
            }else{
                setCartas(null);
                Cartas Panel=new Cartas(Ventana,getJuego().getPartida());
                setCartas(Panel);
            }
            Ventana.add(getCartas());
            getCartas().setVisible(true);
            Ventana.pack();
            Ventana.setLocationRelativeTo(null);
            Ventana.setVisible(true);
        }
    }//GEN-LAST:event_BotonCartasMouseClicked

    private void BotonMapaMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_BotonMapaMouseClicked
        // TODO add your handling code here:
        javax.swing.JFileChooser F=new javax.swing.JFileChooser();

        F.setMultiSelectionEnabled(false);
        
        F.addChoosableFileFilter(new javax.swing.filechooser.FileNameExtensionFilter("Archivos GIF","gif"));
        F.addChoosableFileFilter(new javax.swing.filechooser.FileNameExtensionFilter("Archivos JPEG","jpg","jpeg"));
        F.addChoosableFileFilter(new javax.swing.filechooser.FileNameExtensionFilter("Archivos PNG","png"));
        F.showOpenDialog(this);
       
        if(F.getSelectedFile()!=null){
            EtiquetaNombreMapa.setText(F.getSelectedFile().getAbsolutePath());
            setNombreMapa(CargarImagen(F.getSelectedFile().getPath()));
        }

    }//GEN-LAST:event_BotonMapaMouseClicked
     
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.20E9AD2F-9310-57CC-71CB-EAC2F6D4F5A6]
    // </editor-fold> 
    private void SalirMousePressed (MouseEvent evt) {                                   
        // TODO add your handling code here:
       this.dispose();
    }

  
    /**
     *
     * @param observable
     * @param object
     */
    @Override
    public void update(Observable observable, Object object) {
        if(object.equals(0)){
            java.util.Iterator<PaqueteJuego.Jugador> I= getJuego().getJugadores().iterator();

            PanelNombres.removeAll();
            while(I.hasNext()){
                PaqueteJuego.Jugador Ju=I.next();
                javax.swing.JLabel L=new  javax.swing.JLabel(Ju.getNombre());
                
                L.setOpaque(true);
                L.setForeground(java.awt.Color.WHITE);
                L.setBackground(Ju.getColor());
                L.setVisible(true);
                PanelNombres.add(L);
            }
            PanelNombres.validate();
            PanelNombres.repaint();
           
         }else if(object.equals(1)){
             EtiquetaMarcadorTurno.setText(""+getJuego().getPartida().getTotalTurnos());
             switch (J.getPartida().getTurnoActual()){
                 case 0:  CambiaEstadoConponentes(false,false,false,false,"Selecciona Territorio","");
                          break;
                 case 1:  CambiaEstadoConponentes(false,false,false,false,"Ubicar Tropas","Ejercitos: "+J.getPartida().getJugadorTurno().getEjercitos());
                          EtiquetaInformacion.setText("Ejercitos: "+J.getPartida().getJugadorTurno().getEjercitos());
                          break;
                 case 2:  CambiaEstadoConponentes(true,false,false,true,"Reforzar","Ejercitos: "+J.getPartida().getJugadorTurno().getEjercitos());
                          break;
                 case 3:  CambiaEstadoConponentes(false,false,false,true,"Atacar","");
                          if(J.getPartida().getAtacante()==null){
                            CambiaEstadoConponentes(false,false,false,true,"Atacar","Selecciona Atacante");
                          }else if(J.getPartida().getDefensor()==null){
                           CambiaEstadoConponentes(false,false,false,true,"Atacar","Selecciona Defensor");
                          }else{
                            CambiaEstadoConponentes(false,true,false,true,"Atacar","Inicia el Ataque");
                          }
                          break;
                 case 4:  CambiaEstadoConponentes(false,false,false,true,"Rearmar","");
                          if(J.getPartida().getTerritorioA()==null){
                            CambiaEstadoConponentes(false,false,false,true,"Rearmar","Territorio Origen");
                          }else if(J.getPartida().getTerritorioB()==null){
                            CambiaEstadoConponentes(false,false,false,true,"Rearmar","Territorio Destino");
                          }else{
                            CambiaEstadoConponentes(false,false,true,true,"Rearmar","Inicia el Rearme");
                          }
                          break;

             }
            
             EtiquetaJugador.setBackground(J.getPartida().getJugadorTurno().getColor());
             EtiquetaJugador.setForeground(Color.WHITE);
             EtiquetaJugador.setText(J.getPartida().getJugadorTurno().getNombre());
             
            getTablero().repaint();
                     
        
         }else if(object.equals(2)){
            Jugador Ju=J.getPartida().DameJugadorGanador();
            CreaAviso("Resultado","Jugador Ganador: "+Ju.getNombre());

            J.EliminaJugadorNeutral();
           
            setTablero(null);
            getJuego().getPartida().deleteObservers();
            getJuego().FinalizaPartida();

            VisorTablero.removeAll();
            PanelPrincipal.setSelectedComponent(PanelConfiguracion);
            PanelPrincipal.setEnabledAt(1,false);
            PanelPrincipal.setEnabledAt(0,true);
         }
    }

    private void CambiaEstadoConponentes(boolean A,boolean B,boolean C,boolean D,String T,String I){
        BotonCartas.setEnabled(A);
        BotonAtacar.setEnabled(B);
        BotonRearmar.setEnabled(C);
        BotonCambioTurno.setEnabled(D);
        InformacionTurno.setText(T);
        EtiquetaInformacion.setText(I);
    }
    
    private void CreaAviso(String Titulo,String Mensage){
        final javax.swing.JDialog Ventana=new javax.swing.JDialog(this,Titulo,true);
        javax.swing.JLabel Msg=new  javax.swing.JLabel(Mensage);
               
        Ventana.getContentPane().setLayout(new java.awt.GridLayout(2, 1));
        Ventana.add(Msg);
        Ventana.pack();
        Ventana.setResizable(false);
        Ventana.setLocationRelativeTo(null);
        Ventana.setVisible(true);
            
    }

    /**
     * 
     * @param nombre
     * @return
     */
    public BufferedImage CargarImagen(String nombre) {
        java.net.URL url=null;
        try {
                
                    File F=new File(nombre);
                    return javax.imageio.ImageIO.read(F);
               
        } catch (Exception e) {
                System.out.println("No se pudo cargar la imagen " + nombre +" de "+ url );
                System.out.println("El error fue : "+e.getClass().getName()+" "+e.getMessage());
                System.exit(0);
                return null;
        }
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton BotonAtacar;
    private javax.swing.JButton BotonCambioTurno;
    private javax.swing.JButton BotonCartas;
    private javax.swing.JButton BotonEliminar;
    private javax.swing.JButton BotonIncluir;
    private javax.swing.JButton BotonJugar;
    private javax.swing.JButton BotonMapa;
    private javax.swing.JButton BotonRearmar;
    private javax.swing.JButton BotonTerminar;
    private javax.swing.JMenuItem CargarPartida;
    private javax.swing.JLabel EtiquetaInfoRonda;
    private javax.swing.JLabel EtiquetaInformacion;
    private javax.swing.JLabel EtiquetaJugador;
    private javax.swing.JLabel EtiquetaMarcadorTurno;
    private javax.swing.JLabel EtiquetaNombre;
    private javax.swing.JLabel EtiquetaNombreMapa;
    private javax.swing.JLabel EtiquetaRondas;
    private javax.swing.JLabel EtiquetaTipoJuego;
    private javax.swing.JMenuItem GuardarPartida;
    private javax.swing.JLabel InformacionTurno;
    private javax.swing.JMenuBar Menu;
    private javax.swing.JMenu MenuArchivo;
    private javax.swing.JTextField NombreJugador;
    private javax.swing.JSpinner NumeroRondas;
    private javax.swing.JPanel PanelConfiguracion;
    private javax.swing.JPanel PanelNombres;
    private javax.swing.JTabbedPane PanelPrincipal;
    private javax.swing.JPanel PanelTablero;
    private javax.swing.JMenuItem Salir;
    private javax.swing.JCheckBox SeleccionAleatoria;
    private javax.swing.JComboBox TipoJuego;
    private javax.swing.JPanel VisorTablero;
    private javax.swing.JSeparator jSeparator1;
    // End of variables declaration//GEN-END:variables

}
