/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package PaqueteJuego;

import java.awt.*;
import java.awt.image.*;
import java.awt.event.MouseEvent.*;
import java.awt.event.*;
import javax.imageio.ImageIO.*;
import java.util.*;
import java.io.*;

/**
 *
 * @author root
 */
public class Tablero extends Canvas {
    private static int Seleccionar_Territorio=0;
    private static int Ubicar_Tropas=1;
    private static int Reforzar=2;
    private static int Atacar=3;
    private static int Rearmar=4;

    private static int Ancho=16;
    private static int Alto=12;
    private int Ancho_Mapa=677;
    private int Alto_Mapa=425;

    ArrayList<Jugador> ListaJugadores;
    ArrayList<Carta> ListaCartas;
    ArrayList<Territorio> ListaTerritorios;

    Partida P;

    Image Imagen;
    Graphics Graficos;
    BufferedImage Fondo;

    /**
     *
     * @param val
     * @param Pa
     * @param N
     */
    public Tablero(ArrayList<Territorio> val,Partida Pa,BufferedImage N){
       this.addMouseListener(new java.awt.event.MouseListener() {

            public void mouseClicked(MouseEvent e) {
                Territorio Te;
                if(P.getTurnoActual()==Seleccionar_Territorio){
                    Te=TerritorioSeleccionado(e.getX(),e.getY());
                    if (Te!=null && Te.getPropietario()==null ){
                        P.AsignaTerritorio(Te, P.getJugadorTurno());
                       
                    }
                    
                }else if(P.getTurnoActual()==Ubicar_Tropas){
                    Te=TerritorioSeleccionado(e.getX(),e.getY());
                    if (Te!=null && Te.getPropietario()==P.getJugadorTurno()){
                        P.AsignaEjercito(Te, P.getJugadorTurno());
                       
                    }

                }else  if(P.getTurnoActual()==Reforzar){
                    Te=TerritorioSeleccionado(e.getX(),e.getY());
                    if (Te!=null && Te.getPropietario()==P.getJugadorTurno()){
                        P.AsignaEjercito(Te, P.getJugadorTurno());
                       
                    }
                }else  if(P.getTurnoActual()==Atacar){
                    Te=TerritorioSeleccionado(e.getX(),e.getY());
                    
                    if(e.getButton()==MouseEvent.BUTTON1){
                        if(P.getAtacante()==null){
                            if ((Te!=null) && (Te.getPropietario()==P.getJugadorTurno()) && (Te.getEjercitos()>1)){
                                P.setAtacante(Te);
                                
                            }
                        }else{
                            if (Te!=null && (Te.getPropietario()!=P.getJugadorTurno()) && P.TerritoriosVecinos(P.getAtacante(),Te)){
                                P.setDefensor(Te);
                               
                            }
                        }
                    }else  if(e.getButton()==MouseEvent.BUTTON3){
                        if(Te==P.getAtacante()){
                            P.setAtacante(null);
                            P.setDefensor(null);
                        }else  if(Te==P.getDefensor()){
                            P.setDefensor(null);
                        }
                       
                    }

                }else  if(P.getTurnoActual()==Rearmar){
                    Te=TerritorioSeleccionado(e.getX(),e.getY());

                    if(e.getButton()==MouseEvent.BUTTON1){
                        if(P.getTerritorioA()==null){
                            if (Te!=null && Te.getPropietario()==P.getJugadorTurno() && (Te.getEjercitos()>1)){
                                P.setTerritorioA(Te);
                            }
                        }else{
                            if (Te!=null && Te.getPropietario()==P.getJugadorTurno()&& P.TerritoriosVecinos(P.getTerritorioA(),Te)){
                                P.setTerritorioB(Te);
                            }
                        }
                    }else  if(e.getButton()==MouseEvent.BUTTON3){
                        if(Te==P.getTerritorioA()){
                            P.setTerritorioA(null);
                            P.setTerritorioB(null);
                        }else  if(Te==P.getTerritorioB()){
                            P.setTerritorioB(null);
                        }
                    }
                    
                }
              
            }

            public void mousePressed(MouseEvent e) {}
            public void mouseReleased(MouseEvent e) {}
            public void mouseEntered(MouseEvent e){}
            public void mouseExited(MouseEvent e) {}
           
        });

        setPartida(Pa);
        setTerritorios(val);
        setFondo(N);
     
    }

    /**
     *
     * @return
     */
    public ArrayList<Territorio> getTerritorios() {
        return this.ListaTerritorios;
    }

    /**
     *
     * @param val
     */
    public void setTerritorios(ArrayList<Territorio> val) {
        this.ListaTerritorios=val;
    }

    /**
     *
     * @return
     */
    public Partida getPartida() {
        return this.P;
    }

    /**
     *
     * @param val
     */
    public void setPartida(Partida val) {
        this.P=val;
    }

    /**
     *
     * @return
     */
    public int getAncho_Mapa() {
        return this.Ancho_Mapa;
    }

    /**
     *
     * @param val
     */
    public void setAncho_Mapa(int val){
        this.Ancho_Mapa=val;
    }

    /**
     *
     * @return
     */
    public int getAlto_Mapa() {
        return this.Alto_Mapa;
    }

    /**
     *
     * @param val
     */
    public void setAlto_Mapa(int val){
        this.Alto_Mapa=val;
    }

    /**
     *
     * @return
     */
    public BufferedImage getFondo() {
        return this.Fondo;
    }

    /**
     *
     * @param val
     */
    public void setFondo(BufferedImage val){
        this.Fondo=val;
    }
    
    /**
     *
     * @param g
     */
    @Override
    public void paint(Graphics g){
        
       

        this.Imagen=null;
        this.Imagen = createImage(getAncho_Mapa(),getAlto_Mapa());
        this.Graficos = this.Imagen.getGraphics();
       
        //Pintamos el tablero en el inicio de las coordenadas
        Graficos.drawImage(getFondo(), 0, 0,getAncho_Mapa(),getAlto_Mapa(),this);
       
        Iterator<Territorio> I=getTerritorios().iterator();
        while(I.hasNext()){
            Territorio Te=I.next();
            int [] XY=Te.getCoordenadas();

            if((P.getAtacante()!=null)&&(P.getAtacante()==Te)){
                Graficos.setColor(Color.WHITE);
                Graficos.fillRect(XY[0]-3, XY[1]-3, Ancho+6,Alto+6);
            }
            if((P.getDefensor()!=null)&&(P.getDefensor()==Te)){
                Graficos.setColor(Color.WHITE);
                Graficos.fillRect(XY[0]-3, XY[1]-3, Ancho+6,Alto+6);
            }
            if((P.getTerritorioA()!=null)&&(P.getTerritorioA()==Te)){
                Graficos.setColor(Color.WHITE);
                Graficos.fillRect(XY[0]-3, XY[1]-3, Ancho+6,Alto+6);
            }
            if((P.getTerritorioB()!=null)&&(P.getTerritorioB()==Te)){
                Graficos.setColor(Color.WHITE);
                Graficos.fillRect(XY[0]-3, XY[1]-3, Ancho+6,Alto+6);
            }
            if (Te.getPropietario()==null){
                Graficos.setColor(Color.GRAY);
            }else{
                Graficos.setColor(Te.getPropietario().getColor());
            }
            if(Te.getCapital()){
              
                Graficos.setColor(Color.black);
                Graficos.fillRect(XY[0]-2, XY[1]-2, Ancho+4, Alto+4);
                Graficos.setColor(Te.getPropietario().getColor());
                Graficos.fillRect(XY[0], XY[1], Ancho, Alto);
                
            }else{
                Graficos.fillRect(XY[0], XY[1], Ancho, Alto);
            }
            Graficos.setColor(Color.WHITE);
            Graficos.setFont(new Font("Sans", Font.TRUETYPE_FONT, Alto));
            Graficos.drawString(""+Te.getEjercitos(), XY[0],XY[1]+10);
          
        }
    
       g.drawImage(this.Imagen,0, 0,this.getWidth(),this.getHeight(), this);
      
   }


    /**
     *
     * @param g
     */
    @Override
    public void update(Graphics g) {
         paint(g);
     }

    /**
     *
     * @param nombre
     * @return
     */
    public BufferedImage CargarImagen(File nombre) {
        java.net.URL url=null;
        try {
                //url = getClass().getResource(nombre);
                return javax.imageio.ImageIO.read(nombre);
        } catch (Exception e) {
                System.out.println("No se pudo cargar la imagen " + nombre +" de "+ url );
                System.out.println("El error fue : "+e.getClass().getName()+" "+e.getMessage());
                System.exit(0);
                return null;
        }
    }


    /**
     *
     * @param X
     * @param Y
     * @return
     */
    public Territorio TerritorioSeleccionado(double X,double Y) {

        Iterator<Territorio> I=getTerritorios().iterator();
        Territorio Te=null;
        boolean Salir=true;
        double ProporcionX=(double)this.getWidth()/getAncho_Mapa();
        double ProporcionY=(double)this.getHeight()/getAlto_Mapa();
        
        X=X / ProporcionX;
        Y=Y / ProporcionY;

        while(I.hasNext() && Salir){
            Te=I.next();
              
            int [] XY=Te.getCoordenadas();
            
            if(X>=XY[0] && X<=XY[0]+Ancho){
                if (Y>=XY[1] && Y<=XY[1]+Alto){
                    Salir=false;
                }else{
                    Te=null;
                }
            }else{
                Te=null;
            }
        }
        return Te;
    }
}
